;;; appt-init.el --- Initialization for appt         -*- lexical-binding: t; -*-

;; Copyright (C) 2014  Tom Willemse

;; Author: Tom Willemse <tom@ryuslash.org>
;; Keywords:

;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.

;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

;;; Commentary:

;; Initialization code for the `appt' library, should get loaded when
;; `appt' is.

;;; Code:

(require 'appt)

(autoload 'jabber-send-message "jabber-chat")
(defvar jabber-connections)

(defun oni:appt-display-window-and-jabber (min-to-app new-time appt-msg)
  "Send a message to my phone jabber account."
  (let ((fmt "%s%s (in %s minutes)"))
    (jabber-send-message
     (car jabber-connections) "phone@ryuslash.org" nil
     (format fmt new-time appt-msg min-to-app) nil))
  (appt-disp-window min-to-app new-time appt-msg))

(setq appt-display-diary nil)


(provide 'appt-init)
;;; appt-init.el ends here
